@echo off
echo C.BAT Lazy changing of directory, Thu 7-Oct-2004
echo By Prof. Timo Salmi, ts@uwasa.fi, (c) 1992-2004
echo.

rem If you are fed up with typing \ in changing the directory
rem with the cd command, this is the batch for you
rem I have regularly used this convenient batch for over a decade

rem E.g. if you have a directory \text\jokes\stupid the just use
rem c text jokes stupid
rem Applying c without parameters takes you to the root directory
rem Drive can be an optional first parameter, e.g. c d: text jokes stupid

rem Applicable all through MS-DOS+Win../95/98/Me and NT/2000/XP
rem However, directory names with spaces not supported

set drive_=
for %%d in (a b c d e f g h i j k l m n o p q r s t u v x y z) do if [%1]==[%%d:] set drive_=%%d:
if [%drive_%]==[] goto _set_dir

if not exist %drive_%\nul goto _err_driv
echo Changing drive to %drive_%
%drive_%
shift

:_set_dir
set dir_=
:_loop
set dir_=%dir_%\%1
shift
if not [%1]==[] goto _loop

if not [%dir_%]==[\] if not exist %dir_%\nul goto _err_dir

echo Changing directory to %dir_%
cd %dir_%
goto _out

:_err_driv
echo Drive %drive_% does not exist
goto _out

:_err_dir
echo Directory %dir_% does not exist

:_out
for %%v in (drive_ dir_) do set %%v=
if "%USERNAME%"=="ts" if not "%dosbox%"=="true" if not "%cmdbox%"=="true" pause
echo on
